#include "Qt.h"
ClassImp(Qt)


Qt::Qt(FilesSet* p_files)
{
  qtmaxch[0]=578;
  qtmaxch[1]=578;
  qtmaxch[2]=288;
  qtmaxch[3]=288;

  COL_NUM[0]=COL_NUM[1]=17;
  COL_NUM[2]=COL_NUM[3]=12;
  ROW_NUM[0]=ROW_NUM[1]=34;
  ROW_NUM[2]=ROW_NUM[3]=24;
  
  qtadd_off=15;
  qtcrate_off[0]=0;
  qtcrate_off[1]=0;
  qtcrate_off[2]=5;
  qtcrate_off[3]=0;
  qtcrate_off[4]=0;
  qtcrate_off[5]=0;
  qtcrate_off[6]=6;
  qtcrate_off[7]=0;
  qtcrate_off[8]=7;
  qtcrate_off[9]=0;
  qtcrate_off[10]=1;
  qtcrate_off[11]=2;
  qtcrate_off[12]=3;
  qtcrate_off[13]=4;
  for(Int_t k=0;k<32;k++)
    {
      for(Int_t j=0;j<16;j++)
	{
	  NTrigMap[k][j]=0;
	  for(Int_t l=0;l<7;l++)
	    {
	      detchan[k][j][l]=-1;
	      if(k==0)detnstb[j][l]=-1;
	    };
	};
    };

  qtMat=new TObjArray(4);
  for(Int_t ii=0;ii<4;ii++)
    {
      qtHist[ii]=0;
      qtMat->AddAtAndExpand(new TMatrix(ROW_NUM[ii],COL_NUM[ii]),ii);
    };
  set_mm_order();
  QtError=0;
  p_qtmap=p_files->p_qtmap();
  p_qtmap2pp=p_files->p_qtmap2pp();
  if((p_qtmap) || (p_qtmap2pp) )
    {
      if(p_qtmap->check())
	{
	  if(p_qtmap->open())
	    {
	      FILE* fp=p_qtmap->fp;
	      char line[200];
	      for(Int_t ins=1;ins<3;ins++)
		{

		  for(Int_t ip=1;ip<3;ip++)
		    {
		      for(Int_t ir=1;ir<21;ir++)
			{
			  for(Int_t ic=1;ic<17;ic++)
			    {
			      if(!feof(fp))
				{
				  fgets(line,200,fp);
				  if(strlen(line)<2)QtError=101;
				  if(QtError){
				    cout<<"readfail : "<<line<<"\n";
				    return;
				  };
				  Int_t rns,rp,rr,rc,rcrt,rslt,rch;
				  sscanf(line,"%d %d %d %d %d %d %d",
					 &rns,&rp,&rr,&rc,&rcrt,&rslt,&rch);
				  if(rns!=-1)
				    {
				      //temporary fix
				      if(rslt==12)rslt=11;
				      //end temporary
				      if(rns!=ins)QtError=102;
				      if(rp!=ip)QtError=103;
				      if(rr!=ir)QtError=104;
				      if(rc!=ic)QtError=105;
				      if(QtError)return;
				      rcrate[rc-1][rr-1][rp-1][rns-1]=rcrt;//counts from 1
				      rslot[rc-1][rr-1][rp-1][rns-1]=rslt;//counts from 1
				      rdcd[rc-1][rr-1][rp-1][rns-1]=rch/8;//counts from 0
				      rdch[rc-1][rr-1][rp-1][rns-1]=rch%8;//counts from 0
				    };
				  
				}
			      else
				{
				  QtError=110;
				  cout<<p_qtmap->FileName<<" read Unexpected EOF\n";
				};
			    };
			};
		    };
		};
	    }
	  else
	    {
	      QtError=120;
	    };
	}
      else
	{
	  cout<<p_qtmap->FileName<<" file open failed\n";
	  QtError=130;
	  return;
	};

      if(p_qtmap2pp->check())
	{
	  if(p_qtmap2pp->open())
	    {
	      FILE*fp=p_qtmap2pp->fp;
	      char line[200];
	      for(Int_t i=1;i<5;i++)//only for fms
		{
		  Int_t m=mm[i-1];//order in which qtmap2pp is organized 
		  for(Int_t j=1;j<=qtmaxch[m-1];j++)
		    {
		      if(!feof(fp))
			{
			  if(!fgets(line,200,fp))QtError=201;
			  if(QtError)return;
			  Int_t modr,chr;
			  sscanf(line,"%d %d %d %d %d",&modr,&chr,
				&( pr[j-1][m-1]),&(rr[j-1][m-1]),
				 &(cr[j-1][m-1]));
			  if(m==modr && j==chr)
			    {
			      Int_t pr0,rr0,cr0,chan0,modr0,chr0,ns0;
			      pr0=pr[j-1][m-1];
			      rr0=rr[j-1][m-1];
			      cr0=cr[j-1][m-1];
			  
			      ns0=(m-1)%2+1;
			      chan0=rdcd[cr0-1][rr0-1][pr0-1][ns0-1]*8+
				rdch[cr0-1][rr0-1][pr0-1][ns0-1];
			      modr0=rslot[cr0-1][rr0-1][pr0-1][ns0-1]-1;
			      chr0=rcrate[cr0-1][rr0-1][pr0-1][ns0-1]-1;
			      detchan[chan0][modr0][chr0]=chr;
			      detnstb[modr0][chr0]=m;
			    }else
			      {
				QtError=202;
				//cout<<"m="<<m<<" j="<<j<<"\n";
				//cout<<line<<"\n";
			      };
			  if(QtError)return;
			}
		      else
			{
			  QtError=203;
			  cout<<p_qtmap2pp->FileName<<" read Unexpected EOF\n";
			  return;
			};		     
		    };
		};
	    };
	}
      else
	{
	  cout<<p_qtmap2pp->FileName<<" open failed\n";
	  QtError=204;
	  return;
	};
    }
  else
    {
      QtError=205;
      cout<<"FilesSet input to Qt does not include qtmap or qtmap2pp \n";
      return;
    };
};
void Qt::initQT()
{
  for(Int_t i=1;i<5;i++)
    {
      for(Int_t j=1;j<17;j++)
	{
	  for(Int_t k=1;k<33;k++)
	    {
	      qtadc[k-1][j-1][i-1]=-1;
	      qttac[k-1][j-1][i-1]=-1;
	      if(k<5)
		{
		  qt8sum[k-1][j-1][i-1]=0;
		};
	    };
	  qtsum[j-1][i-1]=0;
	  qtht[j-1][i-1]=-1;
	  qthtadr[j-1][i-1]=-1;
	};
      fmssum[i-1]=0;
    };
  fmssum[4]=0;
  errfff=0;
};
Bool_t Qt::decodeQT(Int_t nQTdata,UInt_t* QTdata, Int_t IDNEVT)
{
  initQT();
  if(nQTdata==0){return false;}
  else if(QTdata[nQTdata-1]!=0xAC10){return false;};
  Int_t nboard=0;
  ndata=0;
  sumadc=0;
  Int_t crate,crt,add,addr,nentry,j;
  Bool_t header=true;
  for(Int_t i=0;i<nQTdata-1;i++)
    {
      Int_t dat1,dat2;
      if(header)
	{
	  dat1=QTdata[i]/0x10000;
	  dat2=QTdata[i]%0x10000;
	  crate=dat1/0x100;
	  addr=dat1%0x100;
	  crt=qtcrate_off[crate-1];//counts from 1
	  add=addr-qtadd_off;//counts from 1
	  nentry=dat2%0x100;
	  nboard=nboard+1;
	  j=0;
	  if(nentry>0)header=false;
	}
      else
	{
	  j++;
	  ndata++;
	  dat1=QTdata[i]/0x10000;
	  dat2=QTdata[i]%0x10000;
	  Int_t adc=dat2%0x1000;
	  sumadc+=adc;
	  Int_t tdc=dat1%0x20;
	  Int_t dc=dat1/0x4000;
	  Int_t dcc=(dat1/0x800)%8;
	  Int_t ch=dcc+dc*8;    //counts from 0
	  Int_t unused=((dat1%0x800)/32)*8+dat2/0x1000;
	  Int_t qt8=ch/8;
	  if((QTdata[i]==(UInt_t) (-1)) || (unused|=0))
	    {
	      errfff++;
	    }
	  qtadc[ch][add-1][crt-1]=adc;
	  qttac[ch][add-1][crt-1]=tdc;
	  qtsum[add-1][crt-1]+=adc;	  
	  qt8sum[qt8][add-1][crt-1]+=adc;
	  //cout<< "crt="<<crt;
	  //cout<< "add="<<add;
	  //cout<< "ch="<<ch;
	  //cout<< "adc="<<adc<<"\n";;
	  if(adc>qtht[add-1][crt-1])
	    {
	      qtnht[add-1][crt-1]=1;
	      qtht[add-1][crt-1]=adc;
	      qthtadr[add-1][crt-1]=ch;
	    }
	  else if(adc==qtht[add-1][crt-1])
	    {
	      qtnht[add-1][crt-1]++;
	      if(ch/8 <= qthtadr[add-1][crt-1]/8)
		{
		  qtht[add-1][crt-1]=adc;
		  qthtadr[add-1][crt-1]=ch;
		};
	    };
	  if(add!=12)
	    {
	      fmssum[crt-1]+=adc;
	      fmssum[4]+=adc;
	    };
	  if(j==nentry)header=true;	  
	};  
    };

  for(Int_t m=0;m<4;m++)
    {      
      Bool_t flag=false;
      for(Int_t ch=0;ch<qtmaxch[m];ch++)
	{
	  Int_t p=pr[ch][m];
	  Int_t r=rr[ch][m];
	  Int_t c=cr[ch][m];
	  if(p>0 && p<3 && c>0 && r>0 && c<17 && r<21)
	    {
	      Int_t ins=m%2;	      
	      Int_t qt=rcrate[c-1][r-1][p-1][ins];
	      Int_t slot=rslot[c-1][r-1][p-1][ins];
	      Int_t dcd=rdcd[c-1][r-1][p-1][ins];
	      Int_t dch=rdch[c-1][r-1][p-1][ins];
	      Int_t row=ch/COL_NUM[m];
	      Int_t col=ch%COL_NUM[m];
	      Int_t adcval=qtadc[dcd*8+dch][slot-1][qt-1];
	      if(adcval<0)adcval=0;
	      (*((TMatrix*) (qtMat->At(m)) ))(row,col)=adcval;
	      if(qtHist[m] && sumadc<50000)
		{
		  qtHist[m]->Fill(ch,adcval);
		};

	      //cout<<"adc="<<qtadc[dcd*8+dch][slot-1][qt-1]<<"\n";
	    };
	};
      //if(flag)(*((TMatrix*) (qtMat->At(m)) )).Print();
    };
  return true;
};
TMatrix* Qt::tm(Int_t instb)
{
  if(instb>=0 && instb<4)
    {
      return ((TMatrix*) qtMat->At(instb));
    };
  return 0;
};
void Qt::EnableqtHist()
{
  qtHist[0]=new TH2F("qtHistLN","qtHistLN",578,0,578,1024,0,1024);
  qtHist[1]=new TH2F("qtHistLS","qtHistLS",578,0,578,1024,0,1024);
  qtHist[2]=new TH2F("qtHistSN","qtHistSN",288,0,288,1024,0,1024);
  qtHist[3]=new TH2F("qtHistSS","qtHistSS",288,0,288,1024,0,1024);
};

Qt::~Qt()
{
  for(Int_t i=0;i<4;i++)
    {
      if(qtHist[i])delete qtHist[i];
    };
  if(qtMat!=0)
    {
      qtMat->Delete();
      delete qtMat;
    };
  
};

void Qt::DefineTrigMap()
{  
  AddToTrigMapSq("A",1,5,"A0",2);
  AddToTrigMapSq("A",9,13,"A0",3);
  AddToTrigMapSq("A",17,21,"A1",3);
  AddToTrigMapSq("A",25,29,"A2",3);
  
  AddToTrigMapSq("B",1,5,"A3",3);
  AddToTrigMapSq("B",9,13,"B0",3);
  AddToTrigMapSq("B",17,22,"B1",3);
  AddToTrigMapSq("B",23,23,"B1",4);
  AddToTrigMapSq("B",25,30,"B2",3);
  AddToTrigMap("B",31,31,"B2","B3","C0","D0");
  AddToTrigMapSq("C",1,6,"B3",3);
  AddToTrigMap("C",7,7,"B3","C0","C1","D0");
  AddToTrigMapSq("C",9,14,"C0",3);
  AddToTrigMap("C",15,15,"C0","C1","C2","D0");
  AddToTrigMapSq("C",17,22,"C1",3);
  AddToTrigMapSq("C",23,23,"C1",4);

  AddToTrigMapSq("D",1,1,"D0",2);
  AddToTrigMapSq("D",2,2,"D0",2);
  AddToTrigMapSq("D",3,3,"D0",2);
  AddToTrigMapSq("D",4,4,"D0",2);
  AddToTrigMapSq("D",5,5,"D0",2);
  AddToTrigMapSq("D",9,13,"D0",3);
  AddToTrigMapSq("D",17,21,"D1",3);
  AddToTrigMapSq("D",25,29,"D2",2);

  AddToTrigMapSq("E",9,14,"E0",3);
  AddToTrigMapSq("E",17,22,"E1",3);
  AddToTrigMapSq("E",25,30,"E2",3);

  AddToTrigMapSq("F",1,6,"E3",3);
  AddToTrigMapSq("F",9,14,"F0",3);
  AddToTrigMapSq("F",17,22,"F1",3);
  AddToTrigMapSq("F",25,25,"F2",2);
  AddToTrigMapSq("F",26,26,"F2",2);
  AddToTrigMapSq("F",27,27,"F2",2);
  AddToTrigMapSq("F",28,28,"F2",2);
  AddToTrigMapSq("F",29,29,"F2",2);
  AddToTrigMapSq("F",30,30,"F2",2);

  AddToTrigMapSq("G",9,10,"G0",3);
  AddToTrigMap("G",11,11,"G0","G1","G2","F3");
  AddToTrigMapSq("G",17,18,"G1",3);
  AddToTrigMap("G",19,19,"G1","G2","G3","F3");
  AddToTrigMapSq("G",25,26,"G2",3);
  AddToTrigMap("G",27,27,"G2","G3","H0","F3");

  AddToTrigMapSq("H",5,6,"G3",3);
  AddToTrigMap("H",7,7,"F3","G3","H0","H1");
  AddToTrigMapSq("H",9,14,"H0",3);
  AddToTrigMap("H",15,15,"F3","H0","H1","H2");
  AddToTrigMapSq("H",17,22,"H1",3);
  AddToTrigMap("H",23,23,"F3","H1","H2","H3");
  AddToTrigMapSq("H",25,30,"H2",2);

  AddToTrigMapSq("I",1,6,"I0",2);
  AddToTrigMapSq("I",9,14,"I0",3);
  AddToTrigMapSq("I",17,22,"I1",3);
  AddToTrigMapSq("I",25,30,"I2",3);

  AddToTrigMapSq("J",1,6,"I3",3);
  AddToTrigMapSq("J",9,14,"J0",3);
  AddToTrigMapSq("J",17,22,"J1",3);
  AddToTrigMapSq("J",25,30,"J2",2);
}; 

void Qt::AddToTrigMap(char* slot,Int_t ch_min,Int_t ch_max, 
		      char* s0,char* s1,char* s2,char* s3)
{ 
  char* s[4];
  s[0]=s0; s[1]=s1; s[2]=s2; s[3]=s3; 
  char* sA="A";
  char* szero="0";
  Int_t ht_slt=(Int_t)(*slot)-(Int_t)(*sA);

  for(Int_t ch=ch_min;ch<ch_max+1;ch++)
    {
      Int_t nqt8=0;
      for(Int_t j=0;j<4;j++)
	{
	  if(s[j]!="")
	    {
	      char ss[2];
	      sscanf(s[j],"%s",ss);
	      Int_t cl_slt=(Int_t)(ss[0])-(Int_t)(*sA);//slot for qt8 in the cluster sum
	      Int_t cl_qt8=(Int_t)(ss[1])-(Int_t)(*szero);
	      TrigMapslot[ch][ht_slt][j]=cl_slt;
	      TrigMapqt8[ch][ht_slt][j]=cl_qt8;
	      nqt8++;
	    };
	};
      NTrigMap[ch][ht_slt]=nqt8; 
    };
}; 

void Qt::AddToTrigMapSq(char* slot,Int_t ch_min,Int_t ch_max, 
		      char* s0,Int_t nqt8)
{ 
  char* sA="A";
  char* szero="0";
  Int_t ht_slt=(Int_t)(*slot)-(Int_t)(*sA);
  char ss[2];
  ss[0]=*s0;
  ss[1]=*(s0+1);
  Int_t icl_slt=(Int_t)(ss[0])-(Int_t)(*sA);
  Int_t icl_qt8=(Int_t)(ss[1])-(Int_t)(*szero);
    
  for(Int_t ch=ch_min;ch<ch_max+1;ch++)
    {
      NTrigMap[ch][ht_slt]=nqt8; 
      Int_t ii=icl_slt*4+icl_qt8;
      for(Int_t j=0;j<nqt8;j++)
	{	  		  
	  Int_t cl_slt=ii/4;
	  Int_t cl_qt8=ii%4; 
	  //printf("ch %d  j %d  cl_slt %d  cl_qt8 %d  ii%d  ht_slt %d \n",ch,j,cl_slt,cl_qt8,ii,ht_slt);
	  TrigMapslot[ch][ht_slt][j]=cl_slt;
	  TrigMapqt8[ch][ht_slt][j]=cl_qt8;
	  ii++;
	};
    };
}; 

