// -*- mode: C++ -*-

#ifndef ST_FMS_ANALYSIS_MAKER_H
#define ST_FMS_ANALYSIS_MAKER_H

// ROOT
class TFile;
class TH1F;
class TH2F;

// PSU-FMS package
class FilesSet;
class Geom;
class Qt;
class CalibStr;
class FitTower;
class Yiqun;
// STAR
#include "StMaker.h"



class StFmsAnalysisMaker : public StMaker {
public:
  StFmsAnalysisMaker(const char* name = "StFmsAnalysisMaker") : StMaker(name) {}
  ~StFmsAnalysisMaker() {}

  void Clear(Option_t* option = "");
  int  Init();
  int  Make();
  int  Finish();
  void SetFile(const char* filename) { mFileName = filename; }
  TMatrix* GetEnergy(Int_t  nstb0){if(nstb0>=0 && nstb0<4)
    {
      return Energy[nstb0];
    } else return 0;}
  TH2F* get_MvsE(){return MvsE;};
  void SetPrintLevel(Int_t lev=1){PrintLevel=lev;};
private:
  TString mFileName;
  TFile* mFile;
  Int_t currentRunNumber;
  FilesSet* mFiles;
  Geom* mGeom;
  Qt* mQt;
  CalibStr* Rped;
  CalibStr* Rgain;
  CalibStr* Rgaincorr;
  TMatrix* Energy[4];
  TH2F* MvsE;
  Int_t PrintLevel;

  ClassDef(StFmsAnalysisMaker,1);
};

#endif	// ST_FMS_ANALYSIS_MAKER_H
